/*
 * demo.x -- demonstrates and tests some jrpcgen features. It doesn't
 *           boil down to a useful example, it just checks a few things
 *           within code generation.
 *
 * To compile, use
 *   java -jar jrpcgen.jar -p tests.org.acplt.oncrpc.jrpcgen -nobackup demo.x
 */

typedef string STRING<>;
typedef STRING STRINGVECTOR<>;

enum ENUMFOO {
    FOO, BAR
};

const FIXEDBUFFERLENGTH = 64;

struct LINKEDLIST {
    int foo;
    struct LINKEDLIST *next;
};

union UNION switch ( bool okay ) {
    case TRUE:
        LINKEDLIST *list;
    default:
        void;
};

struct SILLYSTRUCT {
    char fixedbuffer[512];
    char buffer<128>;
    opaque fixedbytes[FIXEDBUFFERLENGTH];
    opaque bytes<32>;
};

program DEMO {
    version FIRST_DEMO_VERSION {
        void NULL(void) = 0;
        string echo(string) = 1;
        string concat(STRINGVECTOR) = 2;
        bool checkfoo(ENUMFOO) = 3;
        ENUMFOO foo(void) = 4;
        LINKEDLIST ll(LINKEDLIST) = 5;
    } = 1;
} = 0x20049678;

/* End of file demo.x */

